Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2918)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2920)
@@ -5851,13 +5610,4 @@
         ENDDO
 
-!--     calculate the svf threshold
-        svf_threshold = 0._wp
-        IF ( dist_max_svf > 0._wp ) THEN
-            DO d = 0, nsurf_type
-               sqdist = dist_max_svf * dist_max_svf
-               svf_threshold(d) = 1._wp / (pi * sqdist) * facearea(d)
-            ENDDO
-         ENDIF
-         
 !--     initialize variables and temporary arrays for calculation of svf and csf
         nsvfl  = 0
@@ -5873,4 +5623,6 @@
             acsf => acsf1
         ENDIF
+        ray_skip_maxdist = 0
+        ray_skip_minval = 0
         
 !--     initialize temporary terrain and plant canopy height arrays (global 2D array!)
@@ -5888,4 +5640,5 @@
             ALLOCATE( plantt(0:(nx+1)*(ny+1)-1) )
             maxboxesg = nx + ny + nzu + 1
+            max_track_len = nx + ny + 1
 !--         temporary arrays storing values for csf calculation during raytracing
             ALLOCATE( boxes(3, maxboxesg) )
@@ -5893,10 +5646,6 @@
 
 #if defined( __parallel )
-            ALLOCATE( planthl(nys:nyn,nxl:nxr) )
-            planthl = pch(nys:nyn,nxl:nxr)
-        
-            CALL MPI_AllGather( planthl, nnx*nny, MPI_INTEGER, &
+            CALL MPI_AllGather( pct, nnx*nny, MPI_INTEGER, &
                                 plantt, nnx*nny, MPI_INTEGER, comm2d, ierr )
-            DEALLOCATE( planthl )
             
 !--         temporary arrays storing values for csf calculation during raytracing
@@ -5904,5 +5653,5 @@
             ALLOCATE( lad_disp(maxboxesg) )
 
-            IF ( usm_lad_rma )  THEN
+            IF ( rma_lad_raytrace )  THEN
                 ALLOCATE( lad_s_ray(maxboxesg) )
                 
@@ -5922,29 +5671,33 @@
                                         lad_s_rma_p, win_lad, ierr)
                 CALL c_f_pointer(lad_s_rma_p, lad_s_rma, (/ nzu, nny, nnx /))
-                usm_lad(nzub:, nys:, nxl:) => lad_s_rma(:,:,:)
+                sub_lad(nzub:, nys:, nxl:) => lad_s_rma(:,:,:)
             ELSE
-                ALLOCATE(usm_lad(nzub:nzut, nys:nyn, nxl:nxr))
+                ALLOCATE(sub_lad(nzub:nzut, nys:nyn, nxl:nxr))
             ENDIF
 #else
             plantt = RESHAPE( pct(nys:nyn,nxl:nxr), (/(nx+1)*(ny+1)/) )
-            ALLOCATE(usm_lad(nzub:nzut, nys:nyn, nxl:nxr))
+            ALLOCATE(sub_lad(nzub:nzut, nys:nyn, nxl:nxr))
 #endif
-            usm_lad(:,:,:) = 0._wp
+            plantt_max = MAXVAL(plantt)
+            ALLOCATE( rt2_track(2, max_track_len), rt2_track_lad(nzub:plantt_max, max_track_len), &
+                      rt2_track_dist(0:max_track_len), rt2_dist(plantt_max-nzub+2) )
+
+            sub_lad(:,:,:) = 0._wp
             DO i = nxl, nxr
                 DO j = nys, nyn
                     k = get_topography_top_index_ji( j, i, 's' )
 
-                    usm_lad(k:nzut, j, i) = lad_s(0:nzut-k, j, i)
+                    sub_lad(k:nzut, j, i) = lad_s(0:nzut-k, j, i)
                 ENDDO
             ENDDO
 
 #if defined( __parallel )
-            IF ( usm_lad_rma )  THEN
+            IF ( rma_lad_raytrace )  THEN
                 CALL MPI_Info_free(minfo, ierr)
                 CALL MPI_Win_lock_all(0, win_lad, ierr)
             ELSE
-                ALLOCATE( usm_lad_g(0:(nx+1)*(ny+1)*nzu-1) )
-                CALL MPI_AllGather( usm_lad, nnx*nny*nzu, MPI_REAL, &
-                                    usm_lad_g, nnx*nny*nzu, MPI_REAL, comm2d, ierr )
+                ALLOCATE( sub_lad_g(0:(nx+1)*(ny+1)*nzu-1) )
+                CALL MPI_AllGather( sub_lad, nnx*nny*nzu, MPI_REAL, &
+                                    sub_lad_g, nnx*nny*nzu, MPI_REAL, comm2d, ierr )
             ENDIF
 #endif
@@ -6011,22 +5764,116 @@
             CLOSE(154)
         ENDIF  !< mrt_factors
-
+        
+        !--Directions opposite to face normals are not even calculated,
+        !--they must be preset to 0
+        !--
+        dsitrans(:,:) = 0._wp
         
         DO isurflt = 1, nsurfl
 !--         determine face centers
             td = surfl(id, isurflt)
-            IF ( td >= isky  .AND.  .NOT.  plant_canopy ) CYCLE
             ta = (/ REAL(surfl(iz, isurflt), wp) - 0.5_wp * kdir(td),  &
                       REAL(surfl(iy, isurflt), wp) - 0.5_wp * jdir(td),  &
                       REAL(surfl(ix, isurflt), wp) - 0.5_wp * idir(td)  /)
+
+            !--Calculate sky view factor and raytrace DSI paths
+            skyvf(isurflt) = 0._wp
+            skyvft(isurflt) = 0._wp
+
+            !--Select a proper half-sphere for 2D raytracing
+            SELECT CASE ( td )
+               CASE ( iup_u, iup_l )
+                  az0 = 0._wp
+                  naz = raytrace_discrete_azims
+                  azs = 2._wp * pi / REAL(naz, wp)
+                  zn0 = 0._wp
+                  nzn = raytrace_discrete_elevs / 2
+                  zns = pi / 2._wp / REAL(nzn, wp)
+               CASE ( isouth_u, isouth_l )
+                  az0 = pi / 2._wp
+                  naz = raytrace_discrete_azims / 2
+                  azs = pi / REAL(naz, wp)
+                  zn0 = 0._wp
+                  nzn = raytrace_discrete_elevs
+                  zns = pi / REAL(nzn, wp)
+               CASE ( inorth_u, inorth_l )
+                  az0 = - pi / 2._wp
+                  naz = raytrace_discrete_azims / 2
+                  azs = pi / REAL(naz, wp)
+                  zn0 = 0._wp
+                  nzn = raytrace_discrete_elevs
+                  zns = pi / REAL(nzn, wp)
+               CASE ( iwest_u, iwest_l )
+                  az0 = pi
+                  naz = raytrace_discrete_azims / 2
+                  azs = pi / REAL(naz, wp)
+                  zn0 = 0._wp
+                  nzn = raytrace_discrete_elevs
+                  zns = pi / REAL(nzn, wp)
+               CASE ( ieast_u, ieast_l )
+                  az0 = 0._wp
+                  naz = raytrace_discrete_azims / 2
+                  azs = pi / REAL(naz, wp)
+                  zn0 = 0._wp
+                  nzn = raytrace_discrete_elevs
+                  zns = pi / REAL(nzn, wp)
+               CASE DEFAULT
+                  WRITE(message_string, *) 'ERROR: the surface type ',td , ' is not supported for calculating SVF'
+                  CALL message( 'radiation_calc_svf', 'PA0XXX', 1, 2, 0, 6, 0 )
+            END SELECT
+
+            ALLOCATE ( zdirs(1:nzn), zbdry(0:nzn), vffrac(1:nzn), ztransp(1:nzn) )
+            zdirs(:) = (/( TAN(pi/2 - (zn0+(REAL(izn,wp)-.5_wp)*zns)), izn=1, nzn )/)
+            zbdry(:) = (/( zn0+REAL(izn,wp)*zns, izn=0, nzn )/)
+            IF ( td == iup_u  .OR.  td == iup_l )  THEN
+               !-- For horizontal target, vf fractions are constant per azimuth
+               vffrac(:) = (COS(2 * zbdry(0:nzn-1)) - COS(2 * zbdry(1:nzn))) / 2._wp / REAL(naz, wp)
+               !--sum of vffrac for all iaz equals 1, verified
+            ENDIF
+
+            !--Calculate sky-view factor and direct solar visibility using 2D raytracing
+            DO iaz = 1, naz
+               azmid = az0 + (REAL(iaz, wp) - .5_wp) * azs
+               IF ( td /= iup_u  .AND.  td /= iup_l )  THEN
+                  az2 = REAL(iaz, wp) * azs - pi/2._wp
+                  az1 = az2 - azs
+                  !TODO precalculate after 1st line
+                  vffrac(:) = (SIN(az2) - SIN(az1))                           &
+                              * (zbdry(1:nzn) - zbdry(0:nzn-1)                &
+                                 + SIN(zbdry(0:nzn-1))*COS(zbdry(0:nzn-1))    &
+                                 - SIN(zbdry(1:nzn))*COS(zbdry(1:nzn)))       &
+                              / (2._wp * pi)
+                  !--sum of vffrac for all iaz equals 1, verified
+               ENDIF
+               CALL raytrace_2d(ta, (/ COS(azmid), SIN(azmid) /), zdirs,      &
+                                    surfstart(myid) + isurflt, facearea(td),  &
+                                    vffrac, .TRUE., .FALSE., win_lad, horizon,&
+                                    ztransp) !FIXME unit vect in grid units + zdirs
+
+               azen = pi/2 - ATAN(horizon)
+               IF ( td == iup_u  .OR.  td == iup_l )  THEN
+                  azen = MIN(azen, pi/2) !only above horizontal direction
+                  skyvf(isurflt) = skyvf(isurflt) + (1._wp - COS(2*azen)) /   &
+                     (2._wp * raytrace_discrete_azims)
+               ELSE
+                  skyvf(isurflt) = skyvf(isurflt) + (SIN(az2) - SIN(az1)) *   &
+                              (azen - SIN(azen)*COS(azen)) / (2._wp*pi)
+               ENDIF
+               skyvft(isurflt) = skyvft(isurflt) + SUM(ztransp(:) * vffrac(:))
+ 
+               !--Save direct solar transparency
+               j = MODULO(NINT(azmid/                                          &
+                               (2._wp*pi)*raytrace_discrete_azims-.5_wp, iwp), &
+                          raytrace_discrete_azims)
+
+               DO k = 1, raytrace_discrete_elevs/2
+                  i = dsidir_rev(k-1, j)
+                  IF ( i /= -1 )  dsitrans(isurflt, i) = ztransp(k)
+               ENDDO
+            ENDDO
+
+            DEALLOCATE ( zdirs, zbdry, vffrac, ztransp )
+
             DO isurfs = 1, nsurf
-!--             cycle for atmospheric surfaces since they are not source surfaces
-                sd = surf(id, isurfs)
-                IF ( sd > iwest_l  .AND.  sd < isky ) CYCLE
-!--             if reflections between target surfaces (urban and land) are neglected (surf_reflection set to
-!--             FALSE) cycle. This will reduce the number of SVFs and keep SVFs between only ertual surfaces to
-!--             physical surfaces
-                IF ( .NOT.  surf_reflections  .AND. sd < isky ) CYCLE
-!--             cycle if the target and the source surfaces are not facing each other
                 IF ( .NOT.  surface_facing(surfl(ix, isurflt), surfl(iy, isurflt), &
                     surfl(iz, isurflt), surfl(id, isurflt), &
@@ -6036,4 +5883,5 @@
                 ENDIF
                   
+                sd = surf(id, isurfs)
                 sa = (/ REAL(surf(iz, isurfs), wp) - 0.5_wp * kdir(sd),  &
                         REAL(surf(iy, isurfs), wp) - 0.5_wp * jdir(sd),  &
@@ -6044,4 +5892,10 @@
                 sqdist = SUM(uv(:)**2)
                 uv = uv / SQRT(sqdist)
+
+!--             reject raytracing above max distance
+                IF ( SQRT(sqdist) > max_raytracing_dist ) THEN
+                    ray_skip_maxdist = ray_skip_maxdist + 1
+                    CYCLE
+                ENDIF
                 
 !--             irradiance factor (our unshaded shape view factor) = view factor per differential target area * source area
@@ -6051,14 +5905,16 @@
                     * facearea(sd)
 
-!--             skip svf less than svf_threshold
-                IF ( rirrf < svf_threshold(sd) .AND.  sd < isky ) CYCLE
+!--             reject raytracing for potentially too small view factor values
+                IF ( rirrf < min_irrf_value ) THEN
+                    ray_skip_minval = ray_skip_minval + 1
+                    CYCLE
+                ENDIF
 
 !--             raytrace + process plant canopy sinks within
                 CALL raytrace(sa, ta, isurfs, rirrf, facearea(td), .TRUE., &
                         visible, transparency, win_lad)
-                
+
                 IF ( .NOT.  visible ) CYCLE
-                IF ( td >= isky ) CYCLE !< we calculated these only for raytracing
-                                        !< to find plant canopy sinks, we don't need svf for them
+                ! rsvf = rirrf * transparency
 
 !--             write to the svf array
@@ -6080,4 +5936,8 @@
                         DEALLOCATE( asvf1 )
                     ENDIF
+
+!                     WRITE(msg,'(A,3I12)') 'Grow asvf:',nsvfl,nsvfla,k
+!                     CALL radiation_write_debug_log( msg )
+                    
                     nsvfla = k
                 ENDIF
@@ -6090,4 +5950,48 @@
         ENDDO
 
+        !--Raytrace to canopy boxes to fill dsitransc TODO optimize
+        !--
+        dsitransc(:,:) = -999._wp !FIXME
+        az0 = 0._wp
+        naz = raytrace_discrete_azims
+        azs = 2._wp * pi / REAL(naz, wp)
+        zn0 = 0._wp
+        nzn = raytrace_discrete_elevs / 2
+        zns = pi / 2._wp / REAL(nzn, wp)
+        ALLOCATE ( zdirs(1:nzn), vffrac(1:nzn), ztransp(1:nzn) )
+        zdirs(:) = (/( TAN(pi/2 - (zn0+(REAL(izn,wp)-.5_wp)*zns)), izn=1, nzn )/)
+        vffrac(:) = 0._wp
+
+        DO ipcgb = 1, npcbl
+           ta = (/ REAL(pcbl(iz, ipcgb), wp),  &
+                   REAL(pcbl(iy, ipcgb), wp),  &
+                   REAL(pcbl(ix, ipcgb), wp) /)
+           !--Calculate sky-view factor and direct solar visibility using 2D raytracing
+           DO iaz = 1, naz
+              azmid = az0 + (REAL(iaz, wp) - .5_wp) * azs
+              CALL raytrace_2d(ta, (/ COS(azmid), SIN(azmid) /), zdirs,     &
+                                   -999, -999._wp, vffrac, .FALSE., .TRUE., &
+                                   win_lad, horizon, ztransp) !FIXME unit vect in grid units + zdirs
+
+              !--Save direct solar transparency
+              j = MODULO(NINT(azmid/                                         &
+                             (2._wp*pi)*raytrace_discrete_azims-.5_wp, iwp), &
+                         raytrace_discrete_azims)
+              DO k = 1, raytrace_discrete_elevs/2
+                 i = dsidir_rev(k-1, j)
+                 IF ( i /= -1 )  dsitransc(ipcgb, i) = ztransp(k)
+              ENDDO
+           ENDDO
+        ENDDO
+        DEALLOCATE ( zdirs, vffrac, ztransp )
+
+!         CALL radiation_write_debug_log( 'End of calculation SVF' )
+!         WRITE(msg, *) 'Raytracing skipped for maximum distance of ', &
+!             max_raytracing_dist, ' m on ', ray_skip_maxdist, ' pairs.'
+!         CALL radiation_write_debug_log( msg )
+!         WRITE(msg, *) 'Raytracing skipped for minimum potential value of ', &
+!             min_irrf_value , ' on ', ray_skip_minval, ' pairs.'
+!         CALL radiation_write_debug_log( msg )
+
         CALL location_message( '    waiting for completion of SVF and CSF calculation in all processes', .TRUE. )
 !--     deallocate temporary global arrays
@@ -6097,5 +6001,5 @@
 !--         finalize mpi_rma communication and deallocate temporary arrays
 #if defined( __parallel )
-            IF ( usm_lad_rma )  THEN
+            IF ( rma_lad_raytrace )  THEN
                 CALL MPI_Win_flush_all(win_lad, ierr)
 !--             unlock MPI window
@@ -6106,27 +6010,30 @@
 !--             deallocate temporary arrays storing values for csf calculation during raytracing
                 DEALLOCATE( lad_s_ray )
-!--             usm_lad is the pointer to lad_s_rma in case of usm_lad_rma
+!--             sub_lad is the pointer to lad_s_rma in case of rma_lad_raytrace
 !--             and must not be deallocated here
             ELSE
-                DEALLOCATE(usm_lad)
-                DEALLOCATE(usm_lad_g)
+                DEALLOCATE(sub_lad)
+                DEALLOCATE(sub_lad_g)
             ENDIF
 #else
-            DEALLOCATE(usm_lad)
+            DEALLOCATE(sub_lad)
 #endif
             DEALLOCATE( boxes )
             DEALLOCATE( crlens )
             DEALLOCATE( plantt )
+            DEALLOCATE( rt2_track, rt2_track_lad, rt2_track_dist, rt2_dist )
         ENDIF
 
         CALL location_message( '    calculation of the complete SVF array', .TRUE. )
 
+!         CALL radiation_write_debug_log( 'Start SVF sort' )
 !--     sort svf ( a version of quicksort )
         CALL quicksort_svf(asvf,1,nsvfl)
 
+        !< load svf from the structure array to plain arrays
+!         CALL radiation_write_debug_log( 'Load svf from the structure array to plain arrays' )
         ALLOCATE( svf(ndsvf,nsvfl) )
         ALLOCATE( svfsurf(idsvf,nsvfl) )
-
-        !< load svf from the structure array to plain arrays
+        svfnorm_counts(:) = 0._wp
         isurflt_prev = -1
         ksvf = 1
@@ -6136,6 +6043,9 @@
             IF ( asvf(ksvf)%isurflt /= isurflt_prev )  THEN
                 IF ( isurflt_prev /= -1  .AND.  svfsum /= 0._wp )  THEN
-!--                 TODO detect and log when normalization differs too much from 1
-                    svf(1, isvf_surflt:isvf-1) = svf(1, isvf_surflt:isvf-1) / svfsum
+                    !< update histogram of logged svf normalization values
+                    i = searchsorted(svfnorm_report_thresh, svfsum / (1._wp-skyvf(isurflt_prev)))
+                    svfnorm_counts(i) = svfnorm_counts(i) + 1
+
+                    svf(1, isvf_surflt:isvf-1) = svf(1, isvf_surflt:isvf-1) / svfsum * (1._wp-skyvf(isurflt_prev))
                 ENDIF
                 isurflt_prev = asvf(ksvf)%isurflt
@@ -6154,7 +6064,10 @@
 
         IF ( isurflt_prev /= -1  .AND.  svfsum /= 0._wp )  THEN
-!--         TODO detect and log when normalization differs too much from 1
-            svf(1, isvf_surflt:nsvfl) = svf(1, isvf_surflt:nsvfl) / svfsum
+            i = searchsorted(svfnorm_report_thresh, svfsum / (1._wp-skyvf(isurflt_prev)))
+            svfnorm_counts(i) = svfnorm_counts(i) + 1
+
+            svf(1, isvf_surflt:nsvfl) = svf(1, isvf_surflt:nsvfl) / svfsum * (1._wp-skyvf(isurflt_prev))
         ENDIF
+        !TODO we should be able to deallocate skyvf, from now on we only need skyvft
 
 !--     deallocate temporary asvf array
@@ -6172,5 +6085,5 @@
 
             CALL location_message( '    calculation of the complete CSF array', .TRUE. )
-
+!             CALL radiation_write_debug_log( 'Calculation of the complete CSF array' )
 !--         sort and merge csf for the last time, keeping the array size to minimum
             CALL merge_and_grow_csf(-1)
@@ -6243,4 +6156,5 @@
 !--         scatter and gather the number of elements to and from all processor
 !--         and calculate displacements
+!             CALL radiation_write_debug_log( 'Scatter and gather the number of elements to and from all processor' )
             CALL MPI_AlltoAll(icsflt,1,MPI_INTEGER,ipcsflt,1,MPI_INTEGER,comm2d, ierr)
             
@@ -6251,6 +6165,7 @@
                 d = d + ipcsflt(i)
             ENDDO
-        
+
 !--         exchange csf fields between processors
+!             CALL radiation_write_debug_log( 'Exchange csf fields between processors' )
             ALLOCATE( pcsflt(ndcsf,max(npcsfl,ndcsf)) )
             ALLOCATE( kpcsflt(kdcsf,max(npcsfl,kdcsf)) )
@@ -6277,8 +6192,11 @@
 
 !--         sort csf ( a version of quicksort )
+!             CALL radiation_write_debug_log( 'Sort csf' )
             CALL quicksort_csf2(kpcsflt, pcsflt, 1, npcsfl)
 
 !--         aggregate canopy sink factor records with identical box & source
 !--         againg across all values from all processors
+!             CALL radiation_write_debug_log( 'Aggregate canopy sink factor records with identical box' )
+
             IF ( npcsfl > 0 )  THEN
                 icsf = 1 !< reading index
@@ -6326,8 +6244,11 @@
             DEALLOCATE( pcsflt )
             DEALLOCATE( kpcsflt )
-            IF ( ALLOCATED( gridpcbl ) )  DEALLOCATE( gridpcbl )
+!             CALL radiation_write_debug_log( 'End of aggregate csf' )
             
         ENDIF
-        
+
+        CALL MPI_BARRIER( comm2d, ierr )
+!         CALL radiation_write_debug_log( 'End of radiation_calc_svf (after mpi_barrier)' )
+
         RETURN
         
@@ -6336,11 +6257,8 @@
             'plant canopy sink factors / direct irradiance factors.'
         CALL message( 'init_urban_surface', 'PA0502', 2, 2, 0, 6, 0 )
-
-        CALL cpu_log( log_point_s(79), 'radiation_calc_svf', 'stop' )
-
-
+       
     END SUBROUTINE radiation_calc_svf
 
-
+    
 !------------------------------------------------------------------------------!
 ! Description:
@@ -6397,5 +6315,5 @@
 !--     Maximum number of gridboxes visited equals to maximum number of boundaries crossed in each dimension plus one. That's also
 !--     the maximum number of plant canopy boxes written. We grow the acsf array accordingly using exponential factor.
-        maxboxes = SUM(ABS(NINT(targ) - NINT(src))) + 1
+        maxboxes = SUM(ABS(NINT(targ, iwp) - NINT(src, iwp))) + 1
         IF ( plant_canopy  .AND.  ncsfl + maxboxes > ncsfla )  THEN
 !--         use this code for growing by fixed exponential increments (equivalent to case where ncsfl always increases by 1)
@@ -6449,5 +6367,5 @@
             IF ( crlen > .001_wp )  THEN
                 crmid = (lastdist + nextdist) * .5_wp
-                box = NINT(src(:) + uvect(:) * crmid)
+                box = NINT(src(:) + uvect(:) * crmid, iwp)
 
 !--             calculate index of the grid with global indices (box(2),box(3))
@@ -6483,7 +6401,7 @@
         IF ( plant_canopy )  THEN
 #if defined( __parallel )
-            IF ( usm_lad_rma )  THEN
+            IF ( rma_lad_raytrace )  THEN
 !--             send requests for lad_s to appropriate processor
-                CALL cpu_log( log_point_s(77), 'usm_init_rma', 'start' )
+                CALL cpu_log( log_point_s(77), 'rad_init_rma', 'start' )
                 DO i = 1, ncsb
                     CALL MPI_Get(lad_s_ray(i), 1, MPI_REAL, lad_ip(i), lad_disp(i), &
@@ -6501,5 +6419,5 @@
                     CALL message( 'raytrace', 'PA0519', 1, 2, 0, 6, 0 )
                 ENDIF
-                CALL cpu_log( log_point_s(77), 'usm_init_rma', 'stop' )
+                CALL cpu_log( log_point_s(77), 'rad_init_rma', 'stop' )
                 
             ENDIF
@@ -6509,11 +6427,11 @@
             DO i = 1, ncsb
 #if defined( __parallel )
-                IF ( usm_lad_rma )  THEN
+                IF ( rma_lad_raytrace )  THEN
                     lad_s_target = lad_s_ray(i)
                 ELSE
-                    lad_s_target = usm_lad_g(lad_ip(i)*nnx*nny*nzu + lad_disp(i))
+                    lad_s_target = sub_lad_g(lad_ip(i)*nnx*nny*nzu + lad_disp(i))
                 ENDIF
 #else
-                lad_s_target = usm_lad(boxes(1,i),boxes(2,i),boxes(3,i))
+                lad_s_target = sub_lad(boxes(1,i),boxes(2,i),boxes(3,i))
 #endif
                 cursink = 1._wp - exp(-ext_coef * lad_s_target * crlens(i)*realdist)
